<tokens>
<keyword> class </keyword>
<identifier> TicTacToeGame </identifier>
<symbol> { </symbol>
<keyword> static </keyword>
<identifier> Board </identifier>
<identifier> board </identifier>
<symbol> ; </symbol>
<keyword> static </keyword>
<identifier> Piece </identifier>
<identifier> nPiece </identifier>
<symbol> , </symbol>
<identifier> cPiece </identifier>
<symbol> ; </symbol>
<keyword> static </keyword>
<keyword> int </keyword>
<identifier> callCounter </identifier>
<symbol> ; </symbol>
<keyword> static </keyword>
<keyword> boolean </keyword>
<identifier> isDisplay </identifier>
<symbol> ; </symbol>
<keyword> static </keyword>
<keyword> int </keyword>
<identifier> p1 </identifier>
<symbol> ; </symbol>
<keyword> function </keyword>
<keyword> void </keyword>
<identifier> init </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> init </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> nPiece </identifier>
<symbol> = </symbol>
<identifier> Piece </identifier>
<symbol> . </symbol>
<identifier> new </identifier>
<symbol> ( </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> cPiece </identifier>
<symbol> = </symbol>
<identifier> Piece </identifier>
<symbol> . </symbol>
<identifier> new </identifier>
<symbol> ( </symbol>
<integerConstant> 2 </integerConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<keyword> void </keyword>
<identifier> resetStat </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> p1 </identifier>
<symbol> = </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ; </symbol>
<keyword> return </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<keyword> void </keyword>
<identifier> incStat </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> var </keyword>
<identifier> String </identifier>
<identifier> s </identifier>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> p1 </identifier>
<symbol> = </symbol>
<identifier> p1 </identifier>
<symbol> + </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> p1 </identifier>
<symbol> = </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> showMessage </identifier>
<symbol> ( </symbol>
<stringConstant> Thinking... / </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> p1 </identifier>
<symbol> = </symbol>
<integerConstant> 100 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> showMessage </identifier>
<symbol> ( </symbol>
<stringConstant> Thinking... - </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> p1 </identifier>
<symbol> = </symbol>
<integerConstant> 200 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> showMessage </identifier>
<symbol> ( </symbol>
<stringConstant> Thinking... \\ </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> p1 </identifier>
<symbol> = </symbol>
<integerConstant> 300 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> showMessage </identifier>
<symbol> ( </symbol>
<stringConstant> Thinking... | </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> p1 </identifier>
<symbol> = </symbol>
<integerConstant> 400 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> p1 </identifier>
<symbol> = </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> return </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<keyword> int </keyword>
<identifier> processBoard </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> evaluateBoard </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> isWin </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> drawWin </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> isWin </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> return </keyword>
<integerConstant> 3 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> isDraw </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> return </keyword>
<integerConstant> 2 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> return </keyword>
<integerConstant> 1 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<keyword> int </keyword>
<identifier> play </identifier>
<symbol> ( </symbol>
<keyword> int </keyword>
<identifier> player </identifier>
<symbol> , </symbol>
<identifier> Piece </identifier>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> var </keyword>
<keyword> boolean </keyword>
<identifier> validPlayerInput </identifier>
<symbol> ; </symbol>
<keyword> var </keyword>
<keyword> int </keyword>
<identifier> input </identifier>
<symbol> ; </symbol>
<keyword> var </keyword>
<identifier> Array </identifier>
<identifier> playerMove </identifier>
<symbol> , </symbol>
<identifier> computerMove </identifier>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> validPlayerInput </identifier>
<symbol> = </symbol>
<keyword> false </keyword>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> player </identifier>
<symbol> = </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> while </keyword>
<symbol> ( </symbol>
<symbol> ~ </symbol>
<identifier> validPlayerInput </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> input </identifier>
<symbol> = </symbol>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> readInput </identifier>
<symbol> ( </symbol>
<stringConstant> Enter move (1 to 9 or 0 to restart): </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> input </identifier>
<symbol> = </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> return </keyword>
<integerConstant> 0 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> let </keyword>
<identifier> playerMove </identifier>
<symbol> = </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> inputToMove </identifier>
<symbol> ( </symbol>
<identifier> input </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> validPlayerInput </identifier>
<symbol> = </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> isFree </identifier>
<symbol> ( </symbol>
<identifier> playerMove </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> playerMove </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> do </keyword>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> makeMove </identifier>
<symbol> ( </symbol>
<identifier> playerMove </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> playerMove </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> drawMove </identifier>
<symbol> ( </symbol>
<identifier> playerMove </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> playerMove </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> playerMove </identifier>
<symbol> . </symbol>
<identifier> dispose </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> processBoard </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> else </keyword>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> computerMove </identifier>
<symbol> = </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> getComputerMove </identifier>
<symbol> ( </symbol>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> makeMove </identifier>
<symbol> ( </symbol>
<identifier> computerMove </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> computerMove </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> drawMove </identifier>
<symbol> ( </symbol>
<identifier> computerMove </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> computerMove </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> computerMove </identifier>
<symbol> . </symbol>
<identifier> dispose </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> processBoard </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<symbol> } </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<keyword> void </keyword>
<identifier> startGame </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> var </keyword>
<keyword> int </keyword>
<identifier> currentPlayer </identifier>
<symbol> , </symbol>
<identifier> currentPiece </identifier>
<symbol> ; </symbol>
<keyword> var </keyword>
<keyword> boolean </keyword>
<identifier> gameOver </identifier>
<symbol> ; </symbol>
<keyword> var </keyword>
<keyword> int </keyword>
<identifier> gameStatus </identifier>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> showCredits </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> showMessage </identifier>
<symbol> ( </symbol>
<stringConstant> Press enter to start the game! </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> seedGame </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> while </keyword>
<symbol> ( </symbol>
<keyword> true </keyword>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> currentPlayer </identifier>
<symbol> = </symbol>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> waitForZeroOrOne </identifier>
<symbol> ( </symbol>
<stringConstant> First move? (0 for you, 1 for computer):  </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> currentPiece </identifier>
<symbol> = </symbol>
<identifier> cPiece </identifier>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> board </identifier>
<symbol> = </symbol>
<identifier> Board </identifier>
<symbol> . </symbol>
<identifier> new </identifier>
<symbol> ( </symbol>
<integerConstant> 200 </integerConstant>
<symbol> , </symbol>
<integerConstant> 60 </integerConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> gameOver </identifier>
<symbol> = </symbol>
<keyword> false </keyword>
<symbol> ; </symbol>
<keyword> while </keyword>
<symbol> ( </symbol>
<symbol> ~ </symbol>
<identifier> gameOver </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> gameStatus </identifier>
<symbol> = </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> play </identifier>
<symbol> ( </symbol>
<identifier> currentPlayer </identifier>
<symbol> , </symbol>
<identifier> currentPiece </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> gameStatus </identifier>
<symbol> = </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> gameOver </identifier>
<symbol> = </symbol>
<keyword> true </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> gameStatus </identifier>
<symbol> = </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> currentPlayer </identifier>
<symbol> = </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> getOtherPlayer </identifier>
<symbol> ( </symbol>
<identifier> currentPlayer </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> currentPiece </identifier>
<symbol> = </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> getOtherPiece </identifier>
<symbol> ( </symbol>
<identifier> currentPiece </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> gameStatus </identifier>
<symbol> = </symbol>
<integerConstant> 2 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> showMessage </identifier>
<symbol> ( </symbol>
<stringConstant> Game drawn! Press enter to restart! </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> seedGame </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> gameOver </identifier>
<symbol> = </symbol>
<keyword> true </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> gameStatus </identifier>
<symbol> = </symbol>
<integerConstant> 3 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> currentPlayer </identifier>
<symbol> = </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> showMessage </identifier>
<symbol> ( </symbol>
<stringConstant> Congratulations! You won the game! </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> else </keyword>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> InputUtil </identifier>
<symbol> . </symbol>
<identifier> showMessage </identifier>
<symbol> ( </symbol>
<stringConstant> Sorry! You lost the game! Press enter to restart! </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> do </keyword>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> seedGame </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> gameOver </identifier>
<symbol> = </symbol>
<keyword> true </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<symbol> } </symbol>
<keyword> do </keyword>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> dispose </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> return </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<identifier> Array </identifier>
<identifier> getComputerMove </identifier>
<symbol> ( </symbol>
<identifier> Piece </identifier>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> var </keyword>
<identifier> Array </identifier>
<identifier> moves </identifier>
<symbol> ; </symbol>
<keyword> var </keyword>
<identifier> Array </identifier>
<identifier> movesWithScore </identifier>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> resetStat </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> moves </identifier>
<symbol> = </symbol>
<identifier> Array </identifier>
<symbol> . </symbol>
<identifier> new </identifier>
<symbol> ( </symbol>
<integerConstant> 2 </integerConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> getFreeCellCount </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> = </symbol>
<integerConstant> 9 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> return </keyword>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> getRandomGoodMove </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> else </keyword>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> movesWithScore </identifier>
<symbol> = </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> getBestMove </identifier>
<symbol> ( </symbol>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> moves </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> = </symbol>
<identifier> movesWithScore </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> moves </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> = </symbol>
<identifier> movesWithScore </identifier>
<symbol> [ </symbol>
<integerConstant> 2 </integerConstant>
<symbol> ] </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> movesWithScore </identifier>
<symbol> . </symbol>
<identifier> dispose </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<identifier> moves </identifier>
<symbol> ; </symbol>
<symbol> } </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<identifier> Array </identifier>
<identifier> getBestMove </identifier>
<symbol> ( </symbol>
<identifier> Piece </identifier>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> var </keyword>
<keyword> int </keyword>
<identifier> i </identifier>
<symbol> , </symbol>
<identifier> moveCount </identifier>
<symbol> , </symbol>
<identifier> currentScore </identifier>
<symbol> , </symbol>
<identifier> nextScore </identifier>
<symbol> ; </symbol>
<keyword> var </keyword>
<identifier> Array </identifier>
<identifier> moveList </identifier>
<symbol> , </symbol>
<identifier> bestMove </identifier>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> i </identifier>
<symbol> = </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> currentScore </identifier>
<symbol> = </symbol>
<symbol> - </symbol>
<integerConstant> 10 </integerConstant>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> bestMove </identifier>
<symbol> = </symbol>
<identifier> Array </identifier>
<symbol> . </symbol>
<identifier> new </identifier>
<symbol> ( </symbol>
<integerConstant> 3 </integerConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> moveCount </identifier>
<symbol> = </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> getFreeCellCount </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> moveList </identifier>
<symbol> = </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> getAvailableMoves </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> while </keyword>
<symbol> ( </symbol>
<identifier> i </identifier>
<symbol> &lt; </symbol>
<identifier> moveCount </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> incStat </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> makeMove </identifier>
<symbol> ( </symbol>
<identifier> moveList </identifier>
<symbol> [ </symbol>
<identifier> i </identifier>
<symbol> + </symbol>
<identifier> i </identifier>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> moveList </identifier>
<symbol> [ </symbol>
<identifier> i </identifier>
<symbol> + </symbol>
<identifier> i </identifier>
<symbol> + </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> nextScore </identifier>
<symbol> = </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> getMoveScore </identifier>
<symbol> ( </symbol>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> nextScore </identifier>
<symbol> &gt; </symbol>
<identifier> currentScore </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> currentScore </identifier>
<symbol> = </symbol>
<identifier> nextScore </identifier>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> bestMove </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> = </symbol>
<identifier> currentScore </identifier>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> bestMove </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> = </symbol>
<identifier> moveList </identifier>
<symbol> [ </symbol>
<identifier> i </identifier>
<symbol> + </symbol>
<identifier> i </identifier>
<symbol> ] </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> bestMove </identifier>
<symbol> [ </symbol>
<integerConstant> 2 </integerConstant>
<symbol> ] </symbol>
<symbol> = </symbol>
<identifier> moveList </identifier>
<symbol> [ </symbol>
<identifier> i </identifier>
<symbol> + </symbol>
<identifier> i </identifier>
<symbol> + </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> do </keyword>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> takeBackMove </identifier>
<symbol> ( </symbol>
<identifier> moveList </identifier>
<symbol> [ </symbol>
<identifier> i </identifier>
<symbol> + </symbol>
<identifier> i </identifier>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> moveList </identifier>
<symbol> [ </symbol>
<identifier> i </identifier>
<symbol> + </symbol>
<identifier> i </identifier>
<symbol> + </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> i </identifier>
<symbol> = </symbol>
<identifier> i </identifier>
<symbol> + </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> do </keyword>
<identifier> moveList </identifier>
<symbol> . </symbol>
<identifier> dispose </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<identifier> bestMove </identifier>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<keyword> int </keyword>
<identifier> getMoveScore </identifier>
<symbol> ( </symbol>
<identifier> Piece </identifier>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> var </keyword>
<identifier> Array </identifier>
<identifier> otherMove </identifier>
<symbol> ; </symbol>
<keyword> var </keyword>
<keyword> int </keyword>
<identifier> otherScore </identifier>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> evaluateBoard </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> isDraw </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> return </keyword>
<integerConstant> 0 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> isWin </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> return </keyword>
<integerConstant> 1 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> let </keyword>
<identifier> otherMove </identifier>
<symbol> = </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> getBestMove </identifier>
<symbol> ( </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> getOtherPiece </identifier>
<symbol> ( </symbol>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> otherScore </identifier>
<symbol> = </symbol>
<identifier> otherMove </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> otherMove </identifier>
<symbol> . </symbol>
<identifier> dispose </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<symbol> - </symbol>
<identifier> otherScore </identifier>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<keyword> int </keyword>
<identifier> getOtherPiece </identifier>
<symbol> ( </symbol>
<identifier> Piece </identifier>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> p </identifier>
<symbol> = </symbol>
<identifier> nPiece </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> return </keyword>
<identifier> cPiece </identifier>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> else </keyword>
<symbol> { </symbol>
<keyword> return </keyword>
<identifier> nPiece </identifier>
<symbol> ; </symbol>
<symbol> } </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<keyword> int </keyword>
<identifier> getOtherPlayer </identifier>
<symbol> ( </symbol>
<keyword> int </keyword>
<identifier> p </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> p </identifier>
<symbol> = </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> return </keyword>
<integerConstant> 1 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> else </keyword>
<symbol> { </symbol>
<keyword> return </keyword>
<integerConstant> 0 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<identifier> Array </identifier>
<identifier> getRandomGoodMove </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> var </keyword>
<keyword> int </keyword>
<identifier> v </identifier>
<symbol> ; </symbol>
<keyword> var </keyword>
<identifier> Array </identifier>
<identifier> moves </identifier>
<symbol> ; </symbol>
<keyword> while </keyword>
<symbol> ( </symbol>
<keyword> true </keyword>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> v </identifier>
<symbol> = </symbol>
<identifier> Random </identifier>
<symbol> . </symbol>
<identifier> randRange </identifier>
<symbol> ( </symbol>
<integerConstant> 4 </integerConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> v </identifier>
<symbol> = </symbol>
<symbol> ( </symbol>
<identifier> v </identifier>
<symbol> * </symbol>
<integerConstant> 2 </integerConstant>
<symbol> ) </symbol>
<symbol> + </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> moves </identifier>
<symbol> = </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> inputToMove </identifier>
<symbol> ( </symbol>
<identifier> v </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> isFree </identifier>
<symbol> ( </symbol>
<identifier> moves </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> moves </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> ) </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> return </keyword>
<identifier> moves </identifier>
<symbol> ; </symbol>
<symbol> } </symbol>
<symbol> } </symbol>
<keyword> return </keyword>
<identifier> moves </identifier>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<identifier> Array </identifier>
<identifier> getRandomMove </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> var </keyword>
<keyword> int </keyword>
<identifier> v </identifier>
<symbol> ; </symbol>
<keyword> var </keyword>
<identifier> Array </identifier>
<identifier> moves </identifier>
<symbol> ; </symbol>
<keyword> while </keyword>
<symbol> ( </symbol>
<keyword> true </keyword>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> v </identifier>
<symbol> = </symbol>
<identifier> Random </identifier>
<symbol> . </symbol>
<identifier> randRange </identifier>
<symbol> ( </symbol>
<integerConstant> 8 </integerConstant>
<symbol> ) </symbol>
<symbol> + </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> moves </identifier>
<symbol> = </symbol>
<identifier> TicTacToeGame </identifier>
<symbol> . </symbol>
<identifier> inputToMove </identifier>
<symbol> ( </symbol>
<identifier> v </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> board </identifier>
<symbol> . </symbol>
<identifier> isFree </identifier>
<symbol> ( </symbol>
<identifier> moves </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> , </symbol>
<identifier> moves </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> ) </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> return </keyword>
<identifier> moves </identifier>
<symbol> ; </symbol>
<symbol> } </symbol>
<symbol> } </symbol>
<keyword> return </keyword>
<identifier> moves </identifier>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<identifier> Array </identifier>
<identifier> inputToMove </identifier>
<symbol> ( </symbol>
<keyword> int </keyword>
<identifier> input </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> var </keyword>
<identifier> Array </identifier>
<identifier> moves </identifier>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> moves </identifier>
<symbol> = </symbol>
<identifier> Array </identifier>
<symbol> . </symbol>
<identifier> new </identifier>
<symbol> ( </symbol>
<integerConstant> 2 </integerConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> moves </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> = </symbol>
<symbol> ( </symbol>
<identifier> input </identifier>
<symbol> - </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ) </symbol>
<symbol> / </symbol>
<integerConstant> 3 </integerConstant>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> moves </identifier>
<symbol> [ </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ] </symbol>
<symbol> = </symbol>
<symbol> ( </symbol>
<identifier> input </identifier>
<symbol> - </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ) </symbol>
<symbol> - </symbol>
<symbol> ( </symbol>
<integerConstant> 3 </integerConstant>
<symbol> * </symbol>
<identifier> moves </identifier>
<symbol> [ </symbol>
<integerConstant> 0 </integerConstant>
<symbol> ] </symbol>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<identifier> moves </identifier>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<keyword> void </keyword>
<identifier> seedGame </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> var </keyword>
<keyword> int </keyword>
<identifier> seedCounter </identifier>
<symbol> ; </symbol>
<keyword> var </keyword>
<keyword> boolean </keyword>
<identifier> enterPressed </identifier>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> enterPressed </identifier>
<symbol> = </symbol>
<keyword> false </keyword>
<symbol> ; </symbol>
<keyword> let </keyword>
<identifier> seedCounter </identifier>
<symbol> = </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ; </symbol>
<keyword> while </keyword>
<symbol> ( </symbol>
<symbol> ~ </symbol>
<identifier> enterPressed </identifier>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> Keyboard </identifier>
<symbol> . </symbol>
<identifier> keyPressed </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> = </symbol>
<integerConstant> 128 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> enterPressed </identifier>
<symbol> = </symbol>
<keyword> true </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> let </keyword>
<identifier> seedCounter </identifier>
<symbol> = </symbol>
<identifier> seedCounter </identifier>
<symbol> + </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ; </symbol>
<keyword> if </keyword>
<symbol> ( </symbol>
<identifier> seedCounter </identifier>
<symbol> &gt; </symbol>
<integerConstant> 25444 </integerConstant>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> let </keyword>
<identifier> seedCounter </identifier>
<symbol> = </symbol>
<integerConstant> 1 </integerConstant>
<symbol> ; </symbol>
<symbol> } </symbol>
<symbol> } </symbol>
<keyword> do </keyword>
<identifier> Random </identifier>
<symbol> . </symbol>
<identifier> setSeed </identifier>
<symbol> ( </symbol>
<identifier> seedCounter </identifier>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<keyword> function </keyword>
<keyword> void </keyword>
<identifier> showCredits </identifier>
<symbol> ( </symbol>
<symbol> ) </symbol>
<symbol> { </symbol>
<keyword> do </keyword>
<identifier> Output </identifier>
<symbol> . </symbol>
<identifier> moveCursor </identifier>
<symbol> ( </symbol>
<integerConstant> 20 </integerConstant>
<symbol> , </symbol>
<integerConstant> 16 </integerConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> Output </identifier>
<symbol> . </symbol>
<identifier> printString </identifier>
<symbol> ( </symbol>
<stringConstant> Tic Tac Toe in Jack Language </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> Output </identifier>
<symbol> . </symbol>
<identifier> moveCursor </identifier>
<symbol> ( </symbol>
<integerConstant> 21 </integerConstant>
<symbol> , </symbol>
<integerConstant> 22 </integerConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> do </keyword>
<identifier> Output </identifier>
<symbol> . </symbol>
<identifier> printString </identifier>
<symbol> ( </symbol>
<stringConstant> By Jayson Joseph </stringConstant>
<symbol> ) </symbol>
<symbol> ; </symbol>
<keyword> return </keyword>
<symbol> ; </symbol>
<symbol> } </symbol>
<symbol> } </symbol>
</tokens>
